#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

void solve() {
    int A, B, k, m;
    cin >> A >> B >> k >> m;
    int s = m - k - 1;
    if (s < 0 || s > (A - 1) * (B - 1) || k > A + B - 2) {
        cout << -1;
        return;
    }
    if (A == 1) {
        if (s == 0) cout << "0 " << B;
        else cout << -1;
        return;
    }
    if (B == 1) {
        if (s == 0) cout << A << " 0";
        else cout << -1;
        return;
    }
    if (s == 0 && B > k) {
        cout << "0 " << k;
        return;
    }
    int q = k*k - 4*s;
    int r = (int) sqrt(q);
    if(r * r!=q){
        cout<<-1;
        return;
    }
    // a - b = r
    // a + b = k
    int a = (r + k) / 2;
    int b = k - a;
    int ansA = -1, ansB = -1;
    if(a >= 0 && b >= 0 && a < A && b < B && a * b == s){
        ansA = a, ansB = b;
    }
    // b - a = r
    // b + a = k
    b = (r + k) / 2;
    a = k - b;
    if(a >= 0 && b >= 0 && a < A && b < B && a * b == s){
        if(ansA == -1 || ansA > a)
        ansA = a, ansB = b;
    }
    cout<<ansA;
    if(ansA != -1) cout<<' '<<ansB;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}