#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

struct p {
    int x, y;

    p(int X, int Y) { this->x = X, this->y = Y; }
};

struct line {
    int a, b, c;

    line(p u, p v) {
        auto [x1, y1] = u;
        auto [x2, y2] = v;
        a = y1 - y2, b = x2 - x1, c = -(a * x1 + b * y1);
    }
};

int online(p a, line l) {
    return a.x * l.a + a.y * l.b + l.c == 0;
}

void solve() {
    int n, t;
    cin >> n >> t;
    vector<p> a(n, {0, 0});
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    line l(a[0], a[1]);
    int ok = 1;
    for (int i = 0; i < n; ++i) {
        if (!online(a[i], l)) ok = 0;
    }
    if (!ok) {
        for (int i = 0; i < n; ++i) {
            cout << 'G';
        }
        return;
    }
    vector<tuple<int, int, int>> b;
    for (auto [x, y]: a) {
        int g = sz(b);
        b.push_back({x, y, g});
    }
    sort(all(b));
    vector<int> ind;
    for (auto [x, y, index]: b)ind.push_back(index);
    vector<char> ans(n, 'C');
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int i2 = i, j2 = j, lim = 1000, cnt = 0;
            while (lim--) {
                int i3 = j2, j3;
                if(i2 == i) cnt++;
                j3 = (j2 + t) % n;
                i2 = i3, j2 = j3;
            }
            if(cnt > 2) {
                ans[ind[i]] = 'G';
                break;
            }
            if(cnt == 1 && ans[ind[i]] != 'B'){
                ans[ind[i]] = 'R';
            }else ans[ind[i]] = 'B';
        }
    }
    for (char an: ans)cout << an << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
/*
 1 5
 E 2
 N 2
 W 4
 S 4
 E 4

 3 4
 W 2
 N 1
 W 1
 N 2
 */