#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int ex[9];

int good(int x, int len) {
    vector<int> b;
    while (sz(b) < len) {
        b.push_back((x % 8) + 1);
        if (!ex[b.back()]) return 0;
        x /= 8;
    }
    vector<int> w(9, -mod);
    for (int i = 0; i < len; ++i) {
        if (i - w[b[i]] < b[i])return 0;
        w[b[i]] = i;
    }
    return 1;
}

int good2(int x, int len, int x2, int len2) {
    vector<int> b;
    while (sz(b) < len) {
        b.push_back((x % 8) + 1);
        x /= 8;
    }
    while (sz(b) < len + len2) {
        b.push_back((x2 % 8) + 1);
        x2 /= 8;
    }
    vector<int> w(9, -mod);
    for (int i = 0; i < len + len2; ++i) {
        if (i - w[b[i]] < b[i])return 0;
        w[b[i]] = i;
    }
    return 1;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    int M = 1;
    for (int i = 0; i < 8; ++i) M *= 8;
    int mx = 1;
    for (int i = 0; i < m; ++i) {
        cin >> a[i], mx = max(mx, a[i]);
        ex[a[i]] = 1;
    }
    vector<int> c, beg;
    for (int mask = 0; mask < M; ++mask) {
        if (good(mask, mx)) c.push_back(mask);
    }
    int N = 1;
    for (int i = 0; i < n % 8; ++i) N *= 8;
    for (int mask = 0; mask < N; ++mask) {
        if (good(mask, n % 8)) beg.push_back(mask);
    }
    if (n < 8) {
        cout << sz(beg);
        return;
    }
    M = sz(c);
    vector<int> dp(M, 1);
    for (int i = 8; i + 7 < n; i += 8) {
        vector<int> new_dp(M);
        for (int j = 0; j < M; ++j) {
            for (int k = 0; k < M; ++k) {
                if (good2(c[j], 8, c[k], 8)) new_dp[j] = (new_dp[j] + dp[k]) % mod;
            }
        }
        dp = new_dp;
    }
    if(n % 8 == 0){
        int ans = 0;
        for (int i = 0; i < M; ++i) ans = (ans + dp[i]) % mod;
        cout<<ans;
        return;
    }
    vector<int>new_dp(N);
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < M; ++j) {
            if(good2(beg[i], n%8, c[j], 8)) new_dp[i] = (new_dp[i] + dp[j]) % mod;
        }
    }
    int ans = 0;
    for (int i = 0; i < N; ++i) {
        ans = (ans + dp[i]) % mod;
    }
    cout<<ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}