#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9+7, maxn = 2e5+1;
int n, p;
vector<tuple<int, int, int>>t;
int sa[maxn], sb[maxn], sab[maxn];
int suma(int l, int r){
    if(l > r || l < 0 || r >= n)return 0;
    return sa[r+1] - sa[l];
}
int sumb(int l, int r){
    if(l > r || l < 0 || r >= n)return 0;
    return sb[r+1] - sb[l];
}
int sumab(int l, int r){
    if(l > r || l < 0 || r >= n)return 0;
    return sab[r+1] - sab[l];
}
void solve(){
    cin>>n>>p;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int Z, A, B;
        cin>>Z>>A>>B;
        t.push_back({Z, A, B});
    }
    sort(all(t));
    vector<int>z, a, b;
    for(auto[Z, A, B]:t)z.push_back(Z), a.push_back(A), b.push_back(B);
    for (int i = 0; i < n; ++i) {
        sa[i+1] = sa[i]+a[i];
        sb[i+1] = sb[i]+b[i];
        sab[i+1] = sab[i] + (a[i] - b[i]) * z[i];
    }
    ans = inf;
    for (int k = 0; k <= n; ++k) {
        int L = 0, R = inf;
        if(k > 0) L = z[k - 1] + 1;
        int c = n - k;
        if(c > 0) R = z[k];
        int cab = sumab(0, k - 1);
        int ca = suma(k, n - 1);
        int cb = sumb(0, k - 1);
        if(ca + cb == 0){
            if(p <= cab){
                ans = min(ans, L);
            }
            continue;
        }
        if(p <= cab){
            ans = min(ans, L);
            continue;
        }
        int X = (p - cab + ca + cb - 1) / (ca + cb);
        if(X <= R){
            ans = min(ans, max(X, L));
        }
    }
    cout<<ans;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _=1;
    //cin>>_;
    while(_--){
        solve();
        cout<<'\n';
    }
    return 0;
}