#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int ex[9];

int good(int x, int lx) {
    vector<int> b;
    while (sz(b) < lx) {
        b.push_back(x % 5 + 1);
        if (!ex[b.back()])return 0;
        x /= 5;
    }
    vector<int> last(6, -inf);
    for (int i = 0; i < 5; ++i) {
        if (i - last[b[i]] < b[i]) return 0;
        last[b[i]] = i;
    }
    return 1;
}

int ok(int x, int lx, int y, int ly) {
    vector<int> b;
    while (sz(b) < lx) {
        b.push_back(x % 5 + 1);
        if (!ex[b.back()])return 0;
        x /= 5;
    }
    while (sz(b) < lx + ly) {
        b.push_back(y % 5 + 1);
        if (!ex[b.back()])return 0;
        y /= 5;
    }
    vector<int> last(6, -inf);
    for (int i = 0; i < lx + ly; ++i) {
        if (i - last[b[i]] < b[i]) return 0;
        last[b[i]] = i;
    }
    return 1;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        ex[a[i]] = 1;
    }
    if (n == 1) {
        cout << m;
        return;
    }
    if (m == 2 && a[0] == 1) {
        vector<vector<int>> dp(2, vector<int>(n));
        dp[0][0] = 1;
        dp[1][0] = 1;
        for (int i = 1; i < a[1]; ++i) {
            dp[0][i] = (dp[0][i - 1] + dp[1][i - 1]) % mod;
            dp[1][i] = 1;
        }
        for (int i = a[1]; i < n; ++i) {
            dp[0][i] = (dp[0][i - 1] + dp[1][i - 1]) % mod;
            dp[1][i] = 1;
            for (int j = 0; j <= i - a[1]; ++j) {
                dp[1][i] = (dp[1][i] + dp[1][j]) % mod;
            }
        }
        int i = n - 1;
        cout << (dp[0][i] + dp[1][i]) % mod;
        return;
    }
    vector<int> c;
    int N = 3125;
    for (int mask = 0; mask < N; ++mask) {
        if (good(mask, 5))c.push_back(mask);
    }
    N = sz(c);
    vector<int> dp(N, 1);
    for (int i = 5; i + 4 < n; i += 5) {
        vector<int> new_dp(N);
        for (int j = 0; j < N; ++j) {
            for (int k = 0; k < N; ++k) {
                if (ok(c[k], 5, c[j], 5)) new_dp[j] = (new_dp[j] + dp[k]) % mod;
            }
        }
        dp = new_dp;
    }
    if (n % 5 == 0) {
        int ans = 0;
        for (int i = 0; i < N; ++i) {
            ans = (ans + dp[i]) % mod;
        }
        cout << ans;
        return;
    }
    vector<int> end;
    int ost = n % 5;
    int Nost = 1;
    for (int i = 0; i < ost; ++i) {
        Nost *= 5;
    }
    for (int i = 0; i < Nost; ++i) {
        if (good(i, ost)) end.push_back(i);
    }
    if(n < 5){
        cout<<sz(end);
        return;
    }
    Nost = sz(end);
    vector<int> new_dp(Nost);
    for (int i = 0; i < Nost; ++i) {
        for (int j = 0; j < N; ++j) {
            if (ok(c[j], 5, end[i], ost)) new_dp[i] = (new_dp[i] + dp[j]) % mod;
        }
    }
    dp = new_dp;
    int ans = 0;
    for (int i = 0; i < Nost; ++i) {
        ans = (ans + dp[i]) % mod;
    }
    cout<<ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}