#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int ex[9];
vector<int> a;

int good(int x, int lx) {
    vector<int> b;
    while (sz(b) < lx) {
        b.push_back(x % 8 + 1);
        if (!ex[b.back()])return 0;
        x /= 8;
    }
    vector<int> last(9, -inf);
    for (int i = 0; i < lx; ++i) {
        if (i - last[b[i]] < b[i]) return 0;
        last[b[i]] = i;
    }
    return 1;
}

int n, m;
vector<int> e;

void rec(vector<int> q, vector<int> last) {
    if (sz(q) == 8) {
        int num = 0, x = 1;
        for (int i = 0; i < 8; ++i) {
            num += q[i] * x;
            x *= 8;
        }
        e.push_back(num);
        return;
    }
    for (int i = 0; i < m; ++i) {
        int pr = last[a[i]];
        if (i - pr >= a[i]) {
            q.push_back(a[i]);
            last[a[i]] = i;
            rec(q, last);
            q.pop_back();
            last[a[i]] = pr;
        }
    }
}

void solve() {
    cin >> n >> m;
    a.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        ex[a[i]] = 1;
    }
    if (n == 1) {
        cout << m;
        return;
    }
    vector<int> c;
    int N = 1;
    for (int i = 0; i < n; ++i) {
        N *= 8;
    }
    vector<int>ind(N);
    for (int mask = 0; mask < N; ++mask) {
        if (good(mask, 8))c.push_back(mask), ind[mask] = sz(c) - 1;
    }
    N = sz(c);
    //fix
    vector<vector<int>> g(N);
    for (int i = 0; i < N; ++i) {
        vector<int> last(m, -mod);
        vector<int> b;
        int x = c[i], len = -8;
        while (sz(b) < 8) {
            b.push_back(x % 8 + 1);
            last[b.back()] = len;
            len++;
            x /= 8;
        }
        rec({}, last);
        for(int j:e) g[i].push_back(ind[j]);
        g.clear();
    }
    //
    vector<int> dp(N, 1);
    for (int i = 8; i + 7 < n; i += 8) {
        vector<int> new_dp(N);
        for (int j = 0; j < N; ++j) {
            for (int k: g[j]) {
                new_dp[j] = (new_dp[j] + dp[k]) % mod;
            }
        }
        dp = new_dp;
    }
    if (n % 8 == 0) {
        int ans = 0;
        for (int i = 0; i < N; ++i) {
            ans = (ans + dp[i]) % mod;
        }
        cout << ans;
        return;
    }
    vector<int> end;
    int ost = n % 8;
    int Nost = 1;
    for (int i = 0; i < ost; ++i) {
        Nost *= 8;
    }
    for (int i = 0; i < Nost; ++i) {
        if (good(i, ost)) end.push_back(i);
    }
    if (n < 8) {
        cout << sz(end);
        return;
    }
    Nost = sz(end);
    vector<int> new_dp(Nost);
    for (int i = 0; i < Nost; ++i) {
        vector<int> last(m, -mod);
        vector<int> b;
        int x = c[i], len = -ost;
        while (sz(b) < 8) {
            b.push_back(x % 8 + 1);
            last[b.back()] = len;
            len++;
            x /= 8;
        }
        rec({}, last);
        for(int j:e)
            new_dp[i] = (new_dp[i] + dp[ind[j]]) % mod;
        g.clear();
    }
    dp = new_dp;
    int ans = 0;
    for (int i = 0; i < Nost; ++i) {
        ans = (ans + dp[i]) % mod;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}