#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

string g(string &s) {
    vector<int> c(9);
    for (int i = 0; i < sz(s) - 1; ++i) {
        string t = s.substr(i, 2);
        if (t == "aa") c[0]++;
        if (t == "ab") c[1]++;
        if (t == "ac") c[2]++;

        if (t == "ba") c[3]++;
        if (t == "bb") c[4]++;
        if (t == "bc") c[5]++;

        if (t == "ca") c[6]++;
        if (t == "cb") c[7]++;
        if (t == "cc") c[8]++;
    }
    string res;
    for (int i = 0; i < 9; ++i) {
        res += to_string(c[i]);
        res += "#";
    }
    return res;
}

int res(int s, int k) {
    int ans = 1;
    for (int i = 0; i < s; ++i) {
        ans = (ans * k) % mod;
    }
    return ans;
}

void solve() {
    int e, q;
    cin >> e >> q;
    if (e == 3) {
        //aa, ab, ac, ba, bb, bc, ca, cb, cc
        unordered_map<string, int> cnt;
        int N = 3;
        for (int n = 1; n <= 13; ++n) {
            vector<char> alf = {'a', 'b', 'c'};
            for (int mask = 0; mask < N; ++mask) {
                int x = mask;
                string t;
                while (sz(t) < n) {
                    t += alf[x % 3];
                    x /= 3;
                }
                auto d = g(t);
                cnt[d]++;
            }
            N *= 3;
        }
        string t;
        while (q--) {
            cin >> t;
            auto d = g(t);
            cout << (cnt[d]) << '\n';
        }
        return;
    }
    while (q--) {
        string s;
        cin >> s;
        int n = sz(s);
        vector<int> c, k(2);
        int i = 0, h = 0, len = 0;
        while (i < n) {
            int i1 = i;
            while (i < n && s[i] == s[i1])i++;
            k[h] += i - i1 - 1;
            len++, h = 1 - h;
        }
        int ans = res(k[0], len - len / 2);
        ans *= res(k[1], len / 2);
        ans %= mod;
        if (len > 1 && len % 2 == 1) {
            ans = (ans + ans - 1 + mod) % mod;
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}